#include <Firebase.h>
#include <FirebaseArduino.h>
#include <FirebaseCloudMessaging.h>
#include <FirebaseError.h>
#include <FirebaseHttpClient.h>
#include <FirebaseObject.h>

#include "DHT.h"
#include <ESP8266WiFi.h>                 


#define DHTPIN D1    // what pin we're connected to
#define FIREBASE_HOST "nodemcuagriproject-default-rtdb.asia-southeast1.firebasedatabase.app/"      
#define FIREBASE_AUTH "p15DNvaLkKLY30CjbKOTcZOy77DDtp7Ushijsqih"            
#define WIFI_SSID "SLT_FIBER"                                  
#define WIFI_PASSWORD "0112157001"

int sensorValue = 0;  // value read from the pot

// Uncomment whatever type you're using!
#define DHTTYPE DHT11   // DHT 11 
//#define DHTTYPE DHT22   // DHT 22  (AM2302)
//#define DHTTYPE DHT21   // DHT 21 (AM2301)

// Initialize DHT sensor for normal 16mhz Arduino
DHT dht(DHTPIN, DHTTYPE);

// ESP8266 Analog Pin ADC0 = A0
const int analogInPin = A0;

void setup() {
  
  Serial.begin(9600); 
  //Serial.println("test!");
 
  dht.begin();
  WiFi.begin(WIFI_SSID, WIFI_PASSWORD);                                  
  Serial.print("Connecting to ");
  Serial.print(WIFI_SSID);
  while (WiFi.status() != WL_CONNECTED) {
    Serial.print(".");
    delay(500);
  }

  Serial.println();
  Serial.print("Connected");
  Serial.print("IP Address: ");
  Serial.println(WiFi.localIP());                               //prints local IP address
  Firebase.begin(FIREBASE_HOST, FIREBASE_AUTH);                 // connect to the firebase
}

void loop() {
  // Wait a few seconds between measurements.
  delay(2000);

  // Reading temperature or humidity takes about 250 milliseconds!
  // Sensor readings may also be up to 2 seconds 'old' (its a very slow sensor)
  float h = dht.readHumidity();
  // Read temperature as Celsius
  float t = dht.readTemperature();
  // Read temperature as Fahrenheit
  //float f = dht.readTemperature(true);
  int moisture_pin = A0; // Moisture sensor PIN
  int output_value; //read Moisture sensor value

  // read the analog in value ADC0
  sensorValue = analogRead(analogInPin);
  
  // Check if any reads failed and exit early (to try again).
  if (isnan(h) || isnan(t) || isnan(f)) {
    Serial.println("Failed to read from DHT sensor!");
    return;
  }

  // Compute heat index
  // Must send in temp in Fahrenheit!
  float hi = dht.computeHeatIndex(f, h);

  Serial.print("Humidity: "); 
  Serial.print(h);
  String fireHumid = String(h) + String("%");
  
  //Serial.print(" %\t");
  Serial.print("% Temperature: "); 
  Serial.print(t);
  Serial.print(" °C ");
  String fireTemp = String(t) + String("°C");
  
  output_value = analogRead(moisture_pin);
  output_value = map(output_value, 1023, 165, 0, 100);
  Serial.print( " Mositure : "); Serial.print(output_value); Serial.println("%");
  String firebaseMois = String (output_value) + String ("%");


  Firebase.pushString("/DHT11/Humidity", fireHumid);            //setup path to send Humidity readings
  Firebase.pushString("/DHT11/Temperature", fireTemp);  //setup path to send Temperature reading
  Firebase.pushString ("Mositure", firebaseMois);   //setup path to send  reading Moisture

    if (Firebase.failed()) 
    {
 
      Serial.print("pushing /logs failed:");
      Serial.println(Firebase.error()); 
      return;
  }
  
  
  Serial.print(" *F\t");
  Serial.print("Heat index: ");
  Serial.print(hi);
  Serial.println(" *F");
  Serial.print("Moisture = ");
  Serial.println(sensorValue);*/
  
}
